//#include <gtk/gtk.h>

#include <libgwymodule/gwymodule-file.h>
//#include <app/file.h>

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>

#include "indent-toolbox.h"
#include "indent-toolbox-common.h"
#include "instrument.h"
#include "fddata.h"
#include "file-utils.h"
#include "gui-utils.h"

#ifndef G_OS_WIN32
#include "resources.h"
#endif

#include "tool_contact.h"
#include "tool_op.h"
#include "tool_op_unc.h"
#include "tool_op_mc.h"

#ifndef NOFORTRAN
#include "tool_op_odr.h"
#include "tool_op_odr_unc.h"
#include "tool_op_odr_mc.h"
#include "tool_twoslopes.h"
#include "tool_twoslopes_unc.h"
#include "tool_twoslopes_mc.h"
#endif

#include "tool_tangent.h"
#include "tool_tangent_unc.h"
#include "tool_tangent_mc.h"
#include "tool_epwork.h"
#include "tool_epwork_unc.h"
#include "tool_creep.h"
#include "tool_relax.h"
#include "tool_hertz.h"
#include "tool_hertz_unc.h"
#include "tool_hertz_mc.h"
#include "tool_Ph2.h"
#include "tool_ppopins.h"
#include "tool_apopins.h"
#include "dialog_about.h"
#include "settings.h"

#ifdef G_OS_WIN32
#include "getline.h"
#include "windows.h"
#endif

#define appname "Niget"



int main(int argc, char *argv[])
{

	Args args;
	gchar fnm[200];
	gchar fnm1[200];
	int fileok, splitok;
	Slopesdata *sldata;
	Hertzdata *hzdata;
	gint istart, iend, ndata, fitinfo;
	FDdata *fddata;
	Instdata *instdata;
	GwyDataLine *x, *y;
	gint i,j;
	FILE *file;
	gint Nmc = 1e2;
	SlopesMCdata *slopesmc;

	//gtk_init (&argc, &argv);
	sprintf(fnm, argv[1]);
	printf("fnm %s \n", fnm);
	printf("strlen %d \n", strlen(fnm));

	init_FDdata(&args.fddata);
	init_Instdata(&args.instdata);
	init_Slopesdata(&args.slopesdata);
	init_SlopesUncdata(&args.slopesunc);
	init_Hertzdata(&args.hertzdata);

	sldata = &args.slopesdata;
	fddata = &args.fddata;
	hzdata = &args.hertzdata;
	instdata = &args.instdata;

	/*read data */
	fddata->filename = g_malloc(strlen(fnm)*sizeof(gchar)+sizeof(gchar));
	strcpy(fddata->filename, fnm);
	printf("fnm %s \n", fddata->filename);
	fddata->fileformat = 1;

	fileok = read_file(fddata);
	printf("fileok %d \n", fileok);
	splitok = split_hF_data(fddata);

	/*prepare data */
	sldata->loadfrom_pct_Fmax = 60;
	sldata->loadto_pct_Fmax = 95;
	sldata->unloadfrom_pct_Fmax = 60;
	sldata->unloadto_pct_Fmax = 95;

	sldata->Finputload = TRUE;
	sldata->Finputunload = TRUE;

	hzdata->radius = 200e-9;
	hzdata->from = 0;
	hzdata->to = 80;
	hzdata->mode = 0;

	args.slopesunc.uh = 1;
	args.slopesunc.uF = 0.001;


	/* TWOSLOPES */
	/*load */
	range_to_indices(sldata->loadfrom_pct_Fmax*0.01*fddata->Fmax, sldata->loadto_pct_Fmax*0.01*fddata->Fmax,
			fddata->Fload, FALSE, &istart, &iend, &ndata);

	x = gwy_data_line_part_extract(fddata->hload, istart, ndata);
	y = gwy_data_line_part_extract(fddata->Fload, istart, ndata);

	fitinfo = slopes_fit_load(x,y, sldata, fddata, instdata, NULL);
	printf("fitinfo %d \n", fitinfo);
	sldata->xloadfit = gwy_data_line_duplicate(x);
	sldata->yloadfit = gwy_data_line_new_alike(y,FALSE);
	for (i=0; i< sldata->xloadfit->res; i++){
		sldata->yloadfit->data[i] =  sldata->gamma*pow(sldata->xloadfit->data[i]-sldata->h0,sldata->n);
}
	g_object_unref(x);
	g_object_unref(y);



	/*unload */
	range_to_indices(sldata->unloadfrom_pct_Fmax*0.01*fddata->Fmax, sldata->unloadto_pct_Fmax*0.01*fddata->Fmax,
			fddata->Funload, TRUE, &istart, &iend, &ndata);

	x = gwy_data_line_part_extract(fddata->hunload, istart, ndata);
	y = gwy_data_line_part_extract(fddata->Funload, istart, ndata);

	fitinfo = slopes_fit_unload(x,y, sldata, fddata, instdata, NULL);
	printf("fitinfo %d \n", fitinfo);
	sldata->xunloadfit = gwy_data_line_duplicate(x);
	sldata->yunloadfit = gwy_data_line_new_alike(y,FALSE);
	for (i=0; i< sldata->xunloadfit->res; i++){
		sldata->yunloadfit->data[i] =  sldata->alpha*pow(sldata->xunloadfit->data[i]-sldata->hp,sldata->m);
	}
	g_object_unref(x);
	g_object_unref(y);


	/* HERTZ */
	range_to_indices(hzdata->from, hzdata->to, fddata->hload, FALSE, &istart, &iend, &ndata);
	x = gwy_data_line_part_extract(fddata->hload, istart, ndata);
	y = gwy_data_line_part_extract(fddata->Fload, istart, ndata);
	hertz_fit(x,y,hzdata, instdata);
	printf("hzdata->Er %g \n", hzdata->Er);
	hzdata->xfit = gwy_data_line_duplicate(x);
	hzdata->yfit = gwy_data_line_part_extract(fddata->hload, 0, ndata);
	for (i=0; i< hzdata->xfit->res; i++){
		hzdata->yfit->data[i] =  hzdata->reg.slope*pow(hzdata->xfit->data[i],1.5)+ hzdata->reg.intercept;
	}


	/*output */
	sprintf(fnm1, "%s__slopes.dat", fnm);
	printf("fnm1 %s \n", fnm1);

/*
	file =fopen(fnm1, "w");
	if (file){
		fprintf(file," %g %g \n", sldata->Hit, sldata->Er);
		fclose(file);
	}
*/
	slopes_write_file(fnm1, &args);
	printf("slopes written \n");

	sprintf(fnm1, "%s__hertz.dat", fnm);
	printf("fnm1 %s \n", fnm1);

/*
	file =fopen(fnm1, "w");
	if (file){
		fprintf(file," %g \n",hzdata->Er);
		fclose(file);
	}*/
	hertz_write_file(fnm1, &args);
	printf("hertz written \n");


	
	slopesmc = &(args.slopesmc);
	init_SlopesMCdata(slopesmc, Nmc); 
	slopes_uncertainty_montecarlo_run_calc(&args);

	sprintf(fnm1, "%s__slopes_mc.dat", fnm);
	printf("fnm1 %s \n", fnm1);
	slopes_mc_write_file(fnm1, &args); 

/*
	file =fopen(fnm1, "w");
	if (file){
		fprintf(file, "%d \n", Nmc);
		sldata = slopesmc->slopesmc;
		for (i = 0 ; i < Nmc; i++){
			fprintf(file," %g %g  \n", sldata->Er, sldata->Hit);
		}
		sldata++;
		fclose(file);
	}
*/	
		
	destroy_SlopesMCdata(slopesmc);
	return 0;
}

