#ifndef INSTRUMENT_H
#define INSTRUMENT_H

#include <glib.h>
#include <libprocess/gwyprocess.h>

enum {
    AREA_TRIVIAL = 0,
    AREA_POLYNOM,
    AREA_DATA,
};

typedef struct {
    gchar *filename;
    GwyDataLine *xdata; /* in nm */
    GwyDataLine *ydata; /* in nm^2 */
    gint mode;
    gint npoly; // = 6 inicializovat a prozatim na to nesahat
    gdouble *polycoef;
    gdouble *polypower;
    gchar **polylabel;
    gdouble xmax;
} Area;

typedef struct {
    gdouble nu;
    gdouble nui;
    gdouble Ei; /* Ei in GPa */
} Instdata;    

void init_Area(Area *area);
void init_Instdata(Instdata *instdata);

gdouble polynom_eval(Area *area, gdouble h);
gdouble eval_area(Area *area, gdouble h);
gdouble eval_area_derivative(Area *area, gdouble h);
gchar* write_area_label(Area *area);
gchar* write_area_file(Area *area);

#endif
